<?php
/*
Plugin Name: Author Only Fields
Description: Restrict fields to the author (and higher) permission levels.
Version: 1.00
CMS Version Required: 3.00
*/


$GLOBALS['authorOnlyField']['tableFields'] =
    array(  'test'  => array('field1','field3'),
            'test2' => array('field2', 'field4')
         );



addFilter('userHasFieldAccess',    'authorOnlyField_checkField',  2);

function authorOnlyField_checkField($hasAccess, $fieldSchema) {
  global $schema, $RECORD, $escapedTableName, $CURRENT_USER, $tableName, $menu, $isMyAccountMenu;

  if(!@$hasAccess) {
    return $hasAccess;
  }
  
  if(!@$GLOBALS['authorOnlyField']['tableFields'][$tableName]) {
    return $hasAccess;
  }
  
  if(!in_array($fieldSchema['name'], $GLOBALS['authorOnlyField']['tableFields'][$tableName])) {
    return $hasAccess;
  }
  
  if(in_array(userSectionAccess($tableName), array('6','7'))) {
    if(@$_REQUEST['action']=='add') {
      return $hasAccess;
    }
    
    if(in_array($fieldSchema['name'], $GLOBALS['authorOnlyField']['tableFields'][$tableName])) {
      if(@$RECORD['createdByUserNum'] != $CURRENT_USER['num']) {
        return false;
      }
    }
  }
  
  if(userSectionAccess($tableName) < '6') {
    if(in_array($fieldSchema['name'], $GLOBALS['authorOnlyField']['tableFields'][$tableName])) {
        return false;
    }
  }
  
  
  return $hasAccess;
  
}




















